> For the complete documentation index, see [llms.txt](https://docs.rallyprotocol.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.rallyprotocol.com/react-native-expo/gasless-transactions/transact-with-a-contract-gaslessly.md).

# Transact with a contract gaslessly

{% hint style="info" %}
An API key is required to use the infrastructure to power gasless transactions. Visit  <https://app.rallyprotocol.com/> to generate both Amoy and Mainnet Polygon API keys.&#x20;
{% endhint %}

## Contract requirements&#x20;

1. **Contract is compatible with the RallyMobile SDK**
   1. Contracts that are [ERC2771 compatible](/react-native-expo/gasless-transactions/guides/add-erc2771recipient.md#if-you-are-able-to-update-the-contract) are natively supported by the RallyMobile SDK. Those that are not ERC2771 compatible must be whitelisted by us, [view the guide here.](/react-native-expo/gasless-transactions/guides/add-erc2771recipient.md#if-you-are-able-to-update-the-contract)

## Transact with contracts with the relay method

To gaslessly execute a transaction with a contract, create a [GSN transaction object](https://github.com/rally-dfs/rly-network-mobile-sdk/blob/736e1de0859bec5230abba80e978f76f43fe2123/src/gsnClient/utils.ts#L16)  and use the `relay()` method to send the transaction to our relayer.

```dart
import { RlyAmoyNetwork } from 'rly-network-mobile-sdk';
import ethers from 'ethers';
....

//get web3 provider

const provider = new ethers.providers.JsonRpcProvider(providerUrl);

//get instance of your contract 

const myContract =  new ethers.Contract(contractAddress, contractAbi, signer);

//populate raw transaction object
const tx = await myContract.populateTransaction.myMethod.(
    param1,
    param2
  );

//get gas estimate for transaction
  const gas = await myContract.estimateGas.myMethod.(param1, param2);

//get current network fee data
  const { maxFeePerGas, maxPriorityFeePerGas } = await provider.getFeeData();

//create relay tx object

  const gsnTx = {
    from: account.address,
    data: tx.data,
    to: tx.to,
    gas: gas._hex,
    maxFeePerGas: maxFeePerGas._hex,
    maxPriorityFeePerGas: maxPriorityFeePerGas._hex,
  } as GsnTransactionDetails;

// relay transaction 

await RlyAmoyNetwork.relay(gsnTx);
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.rallyprotocol.com/react-native-expo/gasless-transactions/transact-with-a-contract-gaslessly.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
